<?php
/*
Plugin Name: Map.ir Maplugin
Plugin URI: http://corp.map.ir/
Description: Adds maps to wordpress!
Author: Aydin Ghane Kh.
Author URI: http://iding.ir/
Text Domain: mapir-maplugin
Domain Path: /languages
Version: 1.0.0
*/

if(!defined('ABSPATH')) exit;

load_plugin_textdomain( "mapir-maplugin", false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

function agk_theme_settings_page(){ ?>
	<ul class="theme-panel-nav">
		<li><a href="?page=theme-panel&tab=generator"><?php _e('Generator', 'mapir-maplugin') ?></a></li>
		<li><a href="?page=theme-panel&tab=documentations"><?php _e('Documentations', 'mapir-maplugin') ?></a></li>
		<!-- <li><a href="?page=theme-panel&tab=options"><?php _e('Options', 'mapir-maplugin') ?></a></li> -->
		<li><a href="?page=theme-panel&tab=about"><?php _e('About', 'mapir-maplugin') ?></a></li>
	</ul><?php

	$tab = filter_input(INPUT_GET, 'tab', FILTER_SANITIZE_STRING);

	if($tab == '') $tab = 'generator';

	if($tab == 'generator'){ ?>
		<div class="tab-division">
			<h2><?php _e('Generator', 'mapir-maplugin') ?></h2>

			<table id="code-generator-map" class="maplugin-table">
				<caption><?php _e('Generate Map Shortcode', 'mapir-maplugin') ?></caption>
				<tr>
					<th><?php _e('Option', 'mapir-maplugin') ?></th>
					<th><?php _e('Value', 'mapir-maplugin') ?></th>
					<th><?php _e('Example', 'mapir-maplugin') ?></th>
				</tr>
				<tr>
					<td><?php _e('Map ID', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="id">
					</td>
					<td>my-map</td>
				</tr>
				<tr>
					<td><?php _e('Width', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="width">
					</td>
					<td>400px <?php _e('or', 'mapir-maplugin') ?> 100%</td>
				</tr>
				<tr>
					<td><?php _e('Height', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="height">
					</td>
					<td>300px <?php _e('or', 'mapir-maplugin') ?> 100vw</td>
				</tr>
				<tr>
					<td><?php _e('Latitude', 'mapir-maplugin') ?><button type="button" name="locate"></button></td>
					<td>
						<input type="text" name="lat">
					</td>
					<td>32.304693</td>
				</tr>
				<tr>
					<td><?php _e('Longitude', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="lng">
					</td>
					<td>55.349247</td>
				</tr>
				<tr>
					<td><?php _e('Zoom', 'mapir-maplugin') ?></td>
					<td>
						<input type="number" name="zoom">
					</td>
					<td>8</td>
				</tr>
				<tr>
					<td><?php _e('Min zoom', 'mapir-maplugin') ?></td>
					<td>
						<input type="number" name="min-zoom">
					</td>
					<td>2</td>
				</tr>
				<tr>
					<td><?php _e('Max zoom', 'mapir-maplugin') ?></td>
					<td>
						<input type="number" name="max-zoom">
					</td>
					<td>16</td>
				</tr>
				<tr>
					<td><?php _e('Zoom Controller', 'mapir-maplugin') ?></td>
					<td>
						<label><input type="radio" name="zoom-controller" value="true"><?php _e('On', 'mapir-maplugin') ?></label>
						<label><input type="radio" name="zoom-controller" value="false" checked="checked"><?php _e('Off', 'mapir-maplugin') ?></label>
					</td>
					<td></td>
				</tr>
				<tr>
					<td></td>
					<td>
						<button type="button" name="generate"><?php _e('Generate', 'mapir-maplugin') ?></button>
					</td>
					<td></td>
				</tr>
			</table>
			<div id="code-result-map" class="code-result">
				<button type="button" name="copy"></button>
				<input type="text" placeholder="<?php _e('Shortcode', 'mapir-maplugin') ?>">
			</div>

			<table id="code-generator-marker" class="maplugin-table">
				<caption><?php _e('Generate Marker Shortcode', 'mapir-maplugin') ?></caption>
				<tr>
					<th><?php _e('Option', 'mapir-maplugin') ?></th>
					<th><?php _e('Value', 'mapir-maplugin') ?></th>
					<th><?php _e('Example', 'mapir-maplugin') ?></th>
				</tr>
				<tr>
					<td><?php _e('Map ID', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="map">
					</td>
					<td>my-map</td>
				</tr>
				<tr>
					<td><?php _e('Latitude', 'mapir-maplugin') ?><button type="button" name="locate"></button></td>
					<td>
						<input type="text" name="lat">
					</td>
					<td>32.304693</td>
				</tr>
				<tr>
					<td><?php _e('Longitude', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="lng">
					</td>
					<td>55.349247</td>
				</tr>
				<tr>
					<td><?php _e('Pan', 'mapir-maplugin') ?></td>
					<td>
						<label><input type="radio" name="pan" value="true"><?php _e('True', 'mapir-maplugin') ?></label>
						<label><input type="radio" name="pan" value="false" checked="checked"><?php _e('False', 'mapir-maplugin') ?></label>
					</td>
					<td></td>
				</tr>
				<tr>
					<td><?php _e('Title', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="title">
					</td>
					<td><?php _e('Popup Title', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td><?php _e('Description', 'mapir-maplugin') ?></td>
					<td>
						<input type="text" name="description">
					</td>
					<td><?php _e('Popup Description', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td><?php _e('Open', 'mapir-maplugin') ?></td>
					<td>
						<label><input type="radio" name="open" value="true"><?php _e('True', 'mapir-maplugin') ?></label>
						<label><input type="radio" name="open" value="false" checked="checked"><?php _e('False', 'mapir-maplugin') ?></label>
					</td>
					<td></td>
				</tr>
				<tr>
					<td><?php _e('Icon', 'mapir-maplugin') ?></td>
					<td>
						<select name="icon">
							<option value="blue"><?php _e('Blue', 'mapir-maplugin') ?></option>
							<option value="red"><?php _e('Red', 'mapir-maplugin') ?></option>
							<option value="green"><?php _e('Green', 'mapir-maplugin') ?></option>
						</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<td></td>
					<td>
						<button type="button" name="generate"><?php _e('Generate', 'mapir-maplugin') ?></button>
					</td>
					<td></td>
				</tr>
			</table>
			<div id="code-result-marker" class="code-result">
				<button type="button" name="copy"></button>
				<input type="text" placeholder="<?php _e('Shortcode', 'mapir-maplugin') ?>">
			</div>
		</div><?php
	}else if($tab == 'options'){ ?>
		<div class="tab-division">
			<h2><?php _e('Options', 'mapir-maplugin') ?></h2>
		</div><?php
	}else if($tab == 'about'){ ?>
		<div class="tab-division">
			<h2><?php _e('About', 'mapir-maplugin') ?></h2>
			<div class="">
				<?php _e('Developed by', 'mapir-maplugin') ?> <a href="http://iding.ir"><?php _e('Aydin Ghane Kh.', 'mapir-maplugin') ?></a> <?php _e('for', 'mapir-maplugin') ?> <a href="https://map.ir"><?php _e('Map', 'mapir-maplugin') ?></a>
			</div>
		</div><?php
	}else if($tab == 'documentations'){ ?>
		<div class="tab-division">
			<h2><?php _e('Documentations', 'mapir-maplugin') ?></h2>

			<table class="maplugin-table">
				<caption><?php _e('Map', 'mapir-maplugin') ?></caption>
				<tr>
					<th><?php _e('Option', 'mapir-maplugin') ?></th>
					<th><?php _e('Type', 'mapir-maplugin') ?></th>
					<th><?php _e('Default', 'mapir-maplugin') ?></th>
					<th><?php _e('Explanation', 'mapir-maplugin') ?></th>
				</tr>
				<tr>
					<td>id</td>
					<td><?php _e('Kebab-case string', 'mapir-maplugin') ?></td>
					<td>map</td>
					<td><?php _e('Map id', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>width</td>
					<td><?php _e('CSS-like value', 'mapir-maplugin') ?></td>
					<td>100%</td>
					<td><?php _e('Box width', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>height</td>
					<td><?php _e('CSS-like value', 'mapir-maplugin') ?></td>
					<td>300px</td>
					<td><?php _e('Box height', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>lat</td>
					<td><?php _e('Latitude', 'mapir-maplugin') ?></td>
					<td>0</td>
					<td><?php _e('Preset latitude', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>lng</td>
					<td><?php _e('Longitude', 'mapir-maplugin') ?></td>
					<td>0</td>
					<td><?php _e('Preset longitude', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>zoom</td>
					<td><?php _e('Integer', 'mapir-maplugin') ?></td>
					<td>6</td>
					<td><?php _e('Preset zoom level', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>min-zoom</td>
					<td><?php _e('Integer', 'mapir-maplugin') ?></td>
					<td>1</td>
					<td><?php _e('Minimum map zoom level', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>max-zoom</td>
					<td><?php _e('Integer', 'mapir-maplugin') ?></td>
					<td>18</td>
					<td><?php _e('Maximum map zoom level', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>zoom-control</td>
					<td><?php _e('Boolean', 'mapir-maplugin') ?></td>
					<td>true</td>
					<td><?php _e('Whether zoom handlers should be displayed or not', 'mapir-maplugin') ?></td>
				</tr>
			</table>
			<h3><?php _e('Example', 'mapir-maplugin') ?>:</h3>
			<div class="maplugin-example">
				[map id="map1" width="100%" height="300px" lat="30" lng="50" zoom="7" min-zoom="2" max-zoom="16" zoom-control="false"]
			</div>

			<table class="maplugin-table">
				<caption><?php _e('Marker', 'mapir-maplugin') ?></caption>
				<tr>
					<th><?php _e('Option', 'mapir-maplugin') ?></th>
					<th><?php _e('Type', 'mapir-maplugin') ?></th>
					<th><?php _e('Default', 'mapir-maplugin') ?></th>
					<th><?php _e('Explanation', 'mapir-maplugin') ?></th>
				</tr>
				<tr>
					<td>map</td>
					<td><?php _e('Kebab-case string', 'mapir-maplugin') ?></td>
					<td>map</td>
					<td><?php _e('Which map to add the marker to', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>lat</td>
					<td><?php _e('Latitude', 'mapir-maplugin') ?></td>
					<td>0</td>
					<td><?php _e('Marker latitude', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>lng</td>
					<td><?php _e('Longitude', 'mapir-maplugin') ?></td>
					<td>0</td>
					<td><?php _e('Marker longitude', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>pan</td>
					<td><?php _e('Boolean', 'mapir-maplugin') ?></td>
					<td>false</td>
					<td><?php _e('Whether or not the map should be paned to the newly added marker', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>title</td>
					<td><?php _e('String', 'mapir-maplugin') ?></td>
					<td>empty</td>
					<td><?php _e('Popup title', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>description</td>
					<td><?php _e('String', 'mapir-maplugin') ?></td>
					<td>empty</td>
					<td><?php _e('Popup description', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>open</td>
					<td><?php _e('Boolean', 'mapir-maplugin') ?></td>
					<td>false</td>
					<td><?php _e('Whether or not popup should be opened on marker creation', 'mapir-maplugin') ?></td>
				</tr>
				<tr>
					<td>icon</td>
					<td><?php _e('String', 'mapir-maplugin') ?></td>
					<td>blue</td>
					<td><?php _e('Marker icon. Can be blue, red or green', 'mapir-maplugin') ?></td>
				</tr>
			</table>
			<h3><?php _e('Example', 'mapir-maplugin') ?>:</h3>
			<div class="maplugin-example">
				[marker map="map1" lat="35" lng="55" pan="true" title="title" description="description" open="true" icon="red"]
			</div>
		</div><?php
	}
}

// Adding link to admin menu
function add_theme_menu_item(){
	add_menu_page(__('Maplugin', 'mapir-maplugin'), __('Maplugin', 'mapir-maplugin'), 'manage_options', 'theme-panel', 'agk_theme_settings_page', null, 99);
}
add_action('admin_menu', 'add_theme_menu_item');

function agk_plugin_resources(){
	wp_enqueue_style('styles', plugins_url() . '/mapir-maplugin/assets/css/styles.css', array(), '20161123');
	wp_style_add_data( 'styles', 'rtl', 'replace' );

	wp_enqueue_script('script', plugins_url() . '/mapir-maplugin/assets/js/script.js', array(), '20161123', true);

	wp_localize_script('script', 'maplugin', array(
		'url' => plugins_url() . '/mapir-maplugin',
	));
}
add_action('wp_enqueue_scripts', 'agk_plugin_resources');

function agk_plugin_resources_admin(){
	wp_enqueue_style('styles', plugins_url() . '/mapir-maplugin/assets/css/styles.css', array(), '20161123');
	wp_style_add_data( 'styles', 'rtl', 'replace' );

	wp_enqueue_script('script', plugins_url() . '/mapir-maplugin/assets/js/script.js', array(), '20161123', true);
}
add_action( 'admin_enqueue_scripts', 'agk_plugin_resources_admin' );

function maplugin_map_handler($opt) {
	$options = shortcode_atts(array(
		'id' => 'map',
		'width' => '100%',
		'height' => '300px',
		'lat' => 32,
		'lng' => 52,
		'zoom' => 5,
		'min-zoom' => 1,
		'max-zoom' => 18,
		'zoom-controller' => 'true',
	), $opt);

	$html = '<div class="maplugin-map" ' .
	'data-id="' . $options['id'] . '" ' .
	'data-width="' . $options['width'] . '" ' .
	'data-height="' . $options['height'] . '" ' .
	'data-lat="' . $options['lat'] . '" ' .
	'data-lng="' . $options['lng'] . '" ' .
	'data-zoom="' . $options['zoom'] . '" ' .
	'data-min-zoom="' . $options['min-zoom'] . '" ' .
	'data-max-zoom="' . $options['max-zoom'] . '" ' .
	'data-zoom-controller="' . $options['zoom-controller'] . '" ' .
	'></div>';

	return $html;
}
add_shortcode('map', 'maplugin_map_handler');

function maplugin_marker_handler($opt) {
	$options = shortcode_atts(array(
		'map' => 'map',
		'lat' => 32,
		'lng' => 52,
		'pan' => 'true',
		'title' => '',
		'description' => '',
		'open' => 'false',
		'icon' => 'blue',
	), $opt);

	$html = '<div class="maplugin-marker" ' .
	'data-map="' . $options['map'] . '" ' .
	'data-lat="' . $options['lat'] . '" ' .
	'data-lng="' . $options['lng'] . '" ' .
	'data-pan="' . $options['pan'] . '" ' .
	'data-title="' . $options['title'] . '" ' .
	'data-description="' . $options['description'] . '" ' .
	'data-open="' . $options['open'] . '" ' .
	'data-icon="' . $options['icon'] . '" ' .
	'></div>';

	return $html;
}
add_shortcode('marker', 'maplugin_marker_handler');

?>
